# include "std.h"
# if LICENCE
   This file is part of cwrite.
   Copyright 2007, Desislav Georgiev.
 
   cwrite is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
 
   cwrite is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with cwrite.  If not, see <http://www.gnu.org/licenses/>.
# endif
# if HEADER
   # include <stdio.h>
   # include <stdlib.h>

   # include "cwrite.h"
   # include "datasystem.h"
   # include "status_line.h"
   # include "string.h"
# endif
# if GLOBAL
   Datachain ** __datachain_first;
   Datachain ** __datachain;
   Datachain ** __datachain_last;
# endif

Datachain * _datachain_creat1()
   { Datachain * _datachain;
     int dataline_max_size;

     _datachain = (Datachain *) calloc(1, sizeof(Datachain));

        // -- set by datasystem_init(dataline_max_size) --
     dataline_max_size = _datasystem->dataline_max_size;

        // -- alloc and clean one symbol more, critical to clear screen --
        // -- see the same remark in file_open() --
    _datachain->_line = (char *) malloc(dataline_max_size + 1);
    _memset(_datachain->_line, ' ', dataline_max_size + 1);

     return _datachain;
   }
Datachain * _datachain_creat(Datasystem * _datasystem)
   { Datachain * _datachain = (Datachain *) calloc(1, sizeof(Datachain));

        // -- set by datasystem_init() --
     int dataline_max_size = _datasystem->dataline_max_size;

        // -- alloc and clean one symbol more, critical to clear screen --
        // -- see the same remark in file_open() --
     _datachain->_line = (char *) malloc(dataline_max_size + 1);
     _memset(_datachain->_line, ' ', dataline_max_size + 1);

     return _datachain;

   }

void datachain_link(Datasystem * _datasystem, Datachain * _datachain_old, Datachain * _datachain_new)
   { if ( ! _datachain_old )
        { _datasystem->_datachain_first = _datachain_new;
          _datasystem->_datachain_last  = _datachain_new;
          return;
        }
     Datachain * _datachain_next = _datachain_old->_next;
     _datachain_new->_prev = _datachain_old;
     _datachain_new->_next = _datachain_next;

     _datachain_old->_next = _datachain_new;
     if ( ! _datachain_next )
        { _datasystem->_datachain_last = _datachain_new;
          _datachain_new->ordinal = _datachain_old->ordinal + 1;
          return;
        }
     _datachain_next->_prev = _datachain_new;
     _datachain_new->ordinal = _datachain_old->ordinal;
     Datachain * _datachain = _datachain_new;
     while ( _datachain )
        { _datachain->ordinal++;
          _datachain = _datachain->_next;
        }

     return;
   }
void datachain_link1(Datachain * _datachain_old, Datachain * _datachain_new)
   {  Datachain * _datachain_next;
      Datachain * _datachain;

      if ( ! _datachain_old )
        { * __datachain_first = _datachain_new;
          * __datachain_last = _datachain_new;
          return;
        }
     _datachain_next = _datachain_old->_next;
     _datachain_new->_prev = _datachain_old;
     _datachain_new->_next = _datachain_next;
     
     _datachain_old->_next = _datachain_new;
      if ( ! _datachain_next )
         { * __datachain_last = _datachain_new;
           _datachain_new->ordinal = _datachain_old->ordinal + 1;
           return;
         }
     _datachain_next->_prev = _datachain_new;

     _datachain_new->ordinal = _datachain_old->ordinal;
     _datachain = _datachain_new;
      while ( _datachain )
         { _datachain->ordinal++;
           _datachain = _datachain->_next;
         }
   }

Datachain * _datachain_insert1()
   { Datachain * _datachain_new = _datachain_creat1();
     Datachain * _datachain = * __datachain;

     datachain_link1(_datachain, _datachain_new);
     datasystem_verify(_datasystem);
     if ( _datachain == * __datachain_detach_end )
        { * __datachain_detach_end = _datachain_new;
        }
     return _datachain_new;
   }
Datachain * _datachain_insert(Datasystem * _datasystem, Datachain * _datachain)
   { Datachain * _datachain_new = _datachain_creat(_datasystem);

     datachain_link(_datasystem, _datachain, _datachain_new);
     datasystem_verify(_datasystem);
     if ( _datachain == _datasystem->_datachain_detach_end )
        { _datasystem->_datachain_detach_end = _datachain_new;
        }
     return _datachain_new;
   }

void datachain_print(Datachain * _datachain)
   { printf("_datachain = %x\n", _datachain);
     printf("  _prev = %x\n", _datachain->_prev);
     printf("  _next = %x\n", _datachain->_next);
     printf("   ordinal = %d\n", _datachain->ordinal);
     return;
   }
void datachain_echo(Datachain * _datachain)
   { status_line_vprintf((char *)"%x:%d %x %x", _datachain, _datachain->ordinal, _datachain->_prev, _datachain->_next);
     return;
   }
void datachain_free(Datachain * _datachain)
   { free(_datachain->_line);
     free(_datachain);
     return;
   }
