# include "std.h"
# if LICENCE
   This file is part of cwrite.
   Copyright 2007, Desislav Georgiev.
 
   cwrite is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
 
   cwrite is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with cwrite.  If not, see <http://www.gnu.org/licenses/>.
# endif
# if HEADER
   //# include <curses.h>
# endif

int string_len(char * _str)
   { int len = 0;
     while ( * _str++ )
        { len++;
        }
     return len;
   }

void string_copy(char * _str1, char * _str2)
   { while ( * _str2 )
        { * _str1++ = * _str2++;
        }
     * _str1 = 0;
     return;
   }
void line_copy(char * _line, char * _str)
   { while ( * _str )
        { * _line++ = * _str++;
        }
     return;
   }
bool string_compare(char * _str1, char * _str2)
   { while ( * _str1 )
       { if ( * _str1++ != * _str2++ )
            { return 0;
            }
       }
     if ( * _str2 )
        { return 0;
        }
     return 1;
   }
void string_append(char * _str1, char * _str2)
   { int len = string_len(_str1);
     string_copy(_str1 + len, _str2);
     return;
   }

int power(int base, int n)
   { if ( n == 0 )
        { return 1;
        }
      return base * power(base, n-1);
   }
int exponent(int number)
   { int k = 0;
     while ( number >= power(10, k) )
        { k++;
        }
     return --k;
   }

void string_from_int(char * _string, int number)
   { int n = exponent(number);
     int digit;
     while ( n >= 0 )
        { digit = number / power(10, n);
          * _string++ = digit + 48;
          number -= digit * power(10, n);  
          n--;
        }
     * _string = 0;

     return;
   }

void * _memset(void * _line, int c, int n)
   { char * _line_point = (char *) _line;

     for (int i = 0; i < n; i++)
        { * _line_point++ = c;
        }

     return _line;
   }
void memcopy(char * _line1, char * _line2, int n)
   { for ( int i = 0; i < n; i++ )
        { * _line1++ = * _line2++;
        }

     return;
   }

bool line_match(char * _line_point, char * _str)
   { while ( * _str )
        { if ( * _line_point++ != * _str++ )
             { return 0;
             }
        }
     return 1;
   }
bool word_match(char * _line_point, char * _str)
   { while ( * _str )
        { if ( * _line_point++ != * _str++ )
             { return 0;
             }
        }
     if ( * _line_point != ' ' )
        { return 0;
        }
     return 1;
   }
